require('dotenv').config();
const { APP_DEBUG, SCRIPT_PROD } = process.env;

const fastify = require('fastify')({ logger: APP_DEBUG == 'true' });
const path = require('path');

fastify.register(require('@fastify/static'), {
    root: path.join(__dirname, 'public'),
    prefix: '/'
});

// load routes from routes.js
require('./routes')(fastify);
console.log('Starting up');

if (SCRIPT_PROD == 'true' && APP_DEBUG == 'true') {
    console.warn('\x1b[33mYou are running a production script with APP_DEBUG=true. App will run \x1b[1;31min development mode.\x1b[0m');
}

fastify.listen({ port: process.env.APP_PORT ?? 8000 }, (err, address) => {
    if (err) throw err;
    console.log(`Listening on ${address}`);
})